import javax.print.DocFlavor;
import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int q = nextInt();
        long[] A = new long[n];
        long[] B = new long[n];
        for (int i = 0; i < n; i++) {
            A[i] = nextLong();
        }
        for (int i = 0; i < n; i++) {
            B[i] = nextLong();
        }
        T[] a = new T[n * n];
        int ind = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                long x = A[i];
                long y = B[j];
                long min = min(x, y);

                for (int k = 2; k <= sqrt(min) + 1; k++) {
                    while ((x % k == 0) && (y % k == 0)) {
                        x = x / k;
                        y = y / k;
                    }
                }
                while ((x % y == 0) && (y % y == 0) && y != 1) {
                    x = x / y;
                    y = y / y;
                }
                while ((y % x == 0) && (x % x == 0) && x != 1) {
                    x = x / x;
                    y = y / x;
                }
                a[ind] = new T(x, y, (double) x / y);
                ind++;
            }
        }
        Arrays.sort(a, new Comparator<T>() {
            @Override
            public int compare(T o1, T o2) {
                return Double.compare(o1.res, o2.res);
            }
        });
        for (int i = 0; i < q; i++) {
            int iAns = nextInt() - 1;
            out.println(a[iAns].a + " " + a[iAns].b);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}

class T {
    long a;
    long b;
    double res;

    public T(long a, long b, double res) {
        this.a = a;
        this.b = b;
        this.res = res;
    }
}